"""
Django settings for multi_auth project.

Generated by 'django-admin startproject' using Django 3.2.5.

For more information on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""
import os
from pathlib import Path

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.2/howto/deployment/checklist/

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ['*']


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',

    # Project apps
    'core',

    # 3rd party apps
    'bootstrap5',
    'django_otp',
    'django_otp.plugins.otp_static',
    'django_otp.plugins.otp_totp',
    'two_factor',
    'mfa',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django_otp.middleware.OTPMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'multi_auth.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': ['templates'],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'multi_auth.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.2/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql_psycopg2',
        'NAME': 'multi_auth',
        'USER': 'root',
        'PASSWORD': 'password',
        'HOST': 'multi_auth_db',
        'PORT': '5432'
    }
}


# Password validation
# https://docs.djangoproject.com/en/3.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

AUTH_USER_MODEL = 'core.AuthUser'

LOGIN_REDIRECT_URL = 'auth:post_auth'
LOGOUT_REDIRECT_URL = 'auth:index'
LOGIN_URL = 'auth:index'

AUTH_ADD_SUCCESS_MESSAGE_TEMPLATE = 'You successfully added {} authentication. Now try to log in again.'
DIGITAL_SIGNATURE_PLAIN_TEXT_TEMPLATE = 'username:{}password_hash:{}date_joined:{}'

# MFA settings

MFA_UNALLOWED_METHODS = ()   # Methods that shouldn't be allowed for the user
MFA_LOGIN_CALLBACK = "core.utils.custom_login"  # A function that should be called by username to login the user
MFA_RECHECK = True           # Allow random rechecking of the user
MFA_RECHECK_MIN = 10         # Minimum interval in seconds
MFA_RECHECK_MAX = 30         # Maximum in seconds
MFA_QUICKLOGIN = True

TOKEN_ISSUER_NAME = "django_mfa2_example"      # TOTP Issuer name

if DEBUG:
    U2F_APPID = "https://localhost"    # URL For U2F
    FIDO_SERVER_ID = u"localhost"      # Server rp id for FIDO2, it the full domain of your project
else:
    U2F_APPID = "https://django-mfa2-example.herokuapp.com"     # URL For U2F
    FIDO_SERVER_ID = u"django-mfa2-example.herokuapp.com"   # Server rp id for FIDO2, it the full domain of your project

FIDO_SERVER_NAME = u"django_mfa2_example"
MFA_SUCCESS_REGISTRATION_MSG = ''

# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.2/howto/static-files/

STATIC_URL = '/static/'

STATICFILES_DIRS = [
    os.path.join(BASE_DIR, "static"),
]

STATIC_ROOT = os.path.join(BASE_DIR, "staticfiles")

# Default primary key field type
# https://docs.djangoproject.com/en/3.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'


try:
    from .local_settings import *
except ImportError:
    pass
